###Additional functions

GroupR2<-function(y,x,groups=1){
	R2<-cor(x,y)^2
	aggregate(R2,list(rep(1:groups,each=nrow(R2)/groups)),sum)[,-1]
}

### 

GroupR2.pvals<-function(y,x,groups=1,reps=999){
	resu<-NULL
	resu$obs<-GroupR2(y,x,groups)
	simu<-array(NA,dim=c(reps,groups,ncol(y)))
	simu.high<-array(0,dim=c(groups,ncol(y)))
	for(i in 1:reps){
		scores.rand<-sapply(as.data.frame(y),sample)
		simu[i,,]<-as.matrix(GroupR2(scores.rand,x,groups))
		simu.high<-simu.high+(simu[i,,]>=resu$obs)
	}
	resu$simu<-colMeans(simu)
	resu$pvals<-(simu.high/reps)
	resu
}

###

moranI<-function(x,w){
	x_bar<-mean(x)
	I<-(nrow(w)/sum(w))*sum(w*matrix((x-x_bar),ncol=1)%*%(x-x_bar))/sum((x-x_bar)^2)
	I
}

##
moranI.pvals<-function(x,w,alternative="greater",reps=99){
	sim<-NULL
	obs<-moranI(x,w)
	for(i in 1:reps){
		sim[i]<-moranI(sample(x),w)
	}
	
	switch()
	
	pval<-ifelse(alternative=="less",1+sum(sim<obs),1+sum(sim>obs))/(1+reps)
	pval
}







rarefy.S<-function(x,n=nrow(x),N=nrow(x)){
K=sum(colSums(x,na.rm=TRUE)>0)
Ni=colSums(x,na.rm=TRUE);Ni<-Ni[Ni>0&!is.na(Ni)]
K-sum(exp(lchoose(N - Ni, n) - lchoose(N, n)))}

POccur<-function(N,Ni,n){1-(factorial(N-n)/factorial(N))*(factorial(N-Ni)/factorial(N-Ni-n))}# Function to calculate prob of occurrence in n sections given Ni occurrences in N sections (without replacement)


GroupR2<-function(y,x,groups=1){
	R2<-cor(x,y)^2
	aggregate(R2,list(rep(1:groups,each=nrow(R2)/groups)),sum)[,-1]
	}

### 

GroupR2.pvals<-function(y,x,groups=1,reps=999){
	resu<-NULL
	resu$obs<-GroupR2(y,x,groups)
	simu<-array(NA,dim=c(reps,groups,ncol(y)))
	simu.high<-array(0,dim=c(groups,ncol(y)))
	for(i in 1:reps){
		scores.rand<-sapply(as.data.frame(y),sample)
		simu[i,,]<-as.matrix(GroupR2(scores.rand,x,groups))
		simu.high<-simu.high+(simu[i,,]>=resu$obs)
		}
	resu$simu<-colMeans(simu)
	resu$pvals<-(simu.high/reps)
	resu
	}

###

moranI<-function(x,w){
	x_bar<-mean(x)
	I<-(nrow(w)/sum(w))*sum(w*matrix((x-x_bar),ncol=1)%*%(x-x_bar))/sum((x-x_bar)^2)
	I
	}

moranI.pvals<-function(x,w,alternative="greater",reps=999){
	sim<-NULL
	obs<-moranI(x,w)
	for(i in 1:reps){
	sim[i]<-moranI(sample(x),w)
	}
	pval<-ifelse(alternative=="less",sum(sim<obs),sum(sim>obs))/reps
	pval
	}

points.ord<-function(coords,value,pch=21,bg=c("#00A600FF",2),col=bg[1+(z>0)]){
z<-value[order(-abs(value))]
coords<-coords[order(-abs(value)),]
points(coords,cex=10*abs(z/diff(range(z))),bg=bg[1+(z>0)],pch=pch,col=col)
}

pie.ord<-function(coords,value,groups,pch=21,bg=c("#00A600FF",2),col=bg[1+(z>0)]){
z<-value[order(-abs(value))]
coords<-coords[order(-abs(value)),]

points(coords,cex=10*abs(z/diff(range(z))),bg=bg[1+(z>0)],pch=pch,col=col)
}


Venn<-function(table,names=c("Environment","Broad scale","Fine scale","Environment&Broad scale","Broad scale&Fine scale","Environment&Fine scale","Environment&Fine scale&Broad scale")){

require(venneuler)

fracs<-round(table$part$indfract[-8,3],2)
fracs[fracs<0]<-0; names(fracs)<-names
venn<-venneuler(fracs)
venn$labels<-paste0(venn$labels,"\n",fracs[c(1:3)])
plot(venn)
}




















